diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 92315627916..2004cad91f7 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -493,369 +564,568 @@ _PG_init(void)
 	ProcessUtility_hook = pgss_ProcessUtility;
 }
 
-/*
- * shmem request callback: Request shared memory resources.
- *
- * This is called at postmaster startup.  Note that the shared memory isn't
- * allocated here yet, this merely register our needs.
- *
- * In EXEC_BACKEND mode, this is also called in each backend, to re-attach to
- * the shared memory area that was already initialized.
- */
-static void
-pgss_shmem_request(void *arg)
-{
-	ShmemRequestHash(.name = "pg_stat_statements hash",
-					 .nelems = pgss_max,
-					 .hash_info.keysize = sizeof(pgssHashKey),
-					 .hash_info.entrysize = sizeof(pgssEntry),
-					 .hash_flags = HASH_ELEM | HASH_BLOBS,
-					 .ptr = &pgss_hash,
-		);
-	ShmemRequestStruct(.name = "pg_stat_statements",
-					   .size = sizeof(pgssSharedState),
-					   .ptr = (void **) &pgss,
-		);
-}
-
-/*
- * shmem init callback: Initialize our shared memory data structures at
- * postmaster startup.
- *
- * Load any pre-existing statistics from file.  Also create and load the
- * query-texts file, which is expected to exist (even if empty) while the
- * module is enabled.
+/*--------------------------------------------------------------------------
+ * pgstat flush helpers: merge per-kind timing counters into shared memory
+ *--------------------------------------------------------------------------
  */
 static void
-pgss_shmem_init(void *arg)
+pgss_flush_kind(pgssCounters * shared, pgssCounters * pending, pgssStoreKind kind)
 {
-	int			tranche_id;
-	FILE	   *file = NULL;
-	FILE	   *qfile = NULL;
-	uint32		header;
-	int32		num;
-	int32		pgver;
-	int32		i;
-	int			buffer_size;
-	char	   *buffer = NULL;
-
-	/*
-	 * We already checked that we're loaded from shared_preload_libraries in
-	 * _PG_init(), so we should not get here after postmaster startup.
-	 */
-	Assert(!IsUnderPostmaster);
-
-	/*
-	 * Initialize the shmem area with no statistics.
-	 */
-	tranche_id = LWLockNewTrancheId("pg_stat_statements");
-	LWLockInitialize(&pgss->lock.lock, tranche_id);
-	pgss->cur_median_usage = ASSUMED_MEDIAN_INIT;
-	pgss->mean_query_len = ASSUMED_LENGTH_INIT;
-	SpinLockInit(&pgss->mutex);
-	pgss->extent = 0;
-	pgss->n_writers = 0;
-	pgss->gc_count = 0;
-	pgss->stats.dealloc = 0;
-	pgss->stats.stats_reset = GetCurrentTimestamp();
-
-	/* The hash table must've also been initialized by now */
-	Assert(pgss_hash != NULL);
-
-	/*
-	 * Set up a shmem exit hook to dump the statistics to disk on postmaster
-	 * (or standalone backend) exit.
-	 */
-	on_shmem_exit(pgss_shmem_shutdown, (Datum) 0);
+	int64		n_a,
+				n_b;
+	double		delta;
 
-	/*
-	 * Load any pre-existing statistics from file.
-	 *
-	 * Note: we don't bother with locks here, because there should be no other
-	 * processes running when this code is reached.
-	 */
+	n_a = shared->calls[kind];
+	n_b = pending->calls[kind];
 
-	/* Unlink query text file possibly left over from crash */
-	unlink(PGSS_TEXT_FILE);
-
-	/* Allocate new query text temp file */
-	qfile = AllocateFile(PGSS_TEXT_FILE, PG_BINARY_W);
-	if (qfile == NULL)
-		goto write_error;
+	shared->calls[kind] += n_b;
+	shared->total_time[kind] += pending->total_time[kind];
 
-	/*
-	 * If we were told not to load old statistics, we're done.  (Note we do
-	 * not try to unlink any old dump file in this case.  This seems a bit
-	 * questionable but it's the historical behavior.)
-	 */
-	if (!pgss_save)
+	if (n_a == 0)
 	{
-		FreeFile(qfile);
-		return;
+		shared->min_time[kind] = pending->min_time[kind];
+		shared->max_time[kind] = pending->max_time[kind];
+		shared->mean_time[kind] = pending->mean_time[kind];
+		shared->sum_var_time[kind] = pending->sum_var_time[kind];
 	}
-
-	/*
-	 * Attempt to load old statistics from the dump file.
-	 */
-	file = AllocateFile(PGSS_DUMP_FILE, PG_BINARY_R);
-	if (file == NULL)
+	else
 	{
-		if (errno != ENOENT)
-			goto read_error;
-		/* No existing persisted stats file, so we're done */
-		FreeFile(qfile);
-		return;
+		if (pending->min_time[kind] < shared->min_time[kind])
+			shared->min_time[kind] = pending->min_time[kind];
+		if (pending->max_time[kind] > shared->max_time[kind])
+			shared->max_time[kind] = pending->max_time[kind];
+
+		/*
+		 * Chan's parallel variance algorithm: combine two sets of (count,
+		 * mean, sum_of_squared_deviations). See
+		 * <http://www.johndcook.com/blog/standard_deviation/>
+		 */
+		delta = pending->mean_time[kind] - shared->mean_time[kind];
+		shared->sum_var_time[kind] +=
+			pending->sum_var_time[kind] +
+			delta * delta * (double) n_a * (double) n_b / (double) (n_a + n_b);
+		shared->mean_time[kind] =
+			shared->total_time[kind] / shared->calls[kind];
 	}
+}
 
-	buffer_size = 2048;
-	buffer = (char *) palloc(buffer_size);
+static bool
+pgss_flush_pending_cb(PgStat_EntryRef *entry_ref, bool nowait)
+{
+	PgStat_PgssPending *pending;
+	PgStatShared_Pgss *shared;
 
-	if (fread(&header, sizeof(uint32), 1, file) != 1 ||
-		fread(&pgver, sizeof(uint32), 1, file) != 1 ||
-		fread(&num, sizeof(int32), 1, file) != 1)
-		goto read_error;
+	pending = (PgStat_PgssPending *) entry_ref->pending;
+	shared = (PgStatShared_Pgss *) entry_ref->shared_stats;
 
-	if (header != PGSS_FILE_HEADER ||
-		pgver != PGSS_PG_MAJOR_VERSION)
-		goto data_error;
+	if (!pgstat_lock_entry(entry_ref, nowait))
+		return false;
 
-	for (i = 0; i < num; i++)
-	{
-		pgssEntry	temp;
-		pgssEntry  *entry;
-		Size		query_offset;
+	shared->key = pending->key;
+
+	pgss_flush_kind(&shared->counters, &pending->counters, PGSS_EXEC);
+
+	if (pgss_track_planning && pending->counters.calls[PGSS_PLAN] > 0)
+		pgss_flush_kind(&shared->counters, &pending->counters, PGSS_PLAN);
+
+	shared->counters.rows += pending->counters.rows;
+	shared->counters.shared_blks_hit += pending->counters.shared_blks_hit;
+	shared->counters.shared_blks_read += pending->counters.shared_blks_read;
+	shared->counters.shared_blks_dirtied += pending->counters.shared_blks_dirtied;
+	shared->counters.shared_blks_written += pending->counters.shared_blks_written;
+	shared->counters.local_blks_hit += pending->counters.local_blks_hit;
+	shared->counters.local_blks_read += pending->counters.local_blks_read;
+	shared->counters.local_blks_dirtied += pending->counters.local_blks_dirtied;
+	shared->counters.local_blks_written += pending->counters.local_blks_written;
+	shared->counters.temp_blks_read += pending->counters.temp_blks_read;
+	shared->counters.temp_blks_written += pending->counters.temp_blks_written;
+	shared->counters.shared_blk_read_time += pending->counters.shared_blk_read_time;
+	shared->counters.shared_blk_write_time += pending->counters.shared_blk_write_time;
+	shared->counters.local_blk_read_time += pending->counters.local_blk_read_time;
+	shared->counters.local_blk_write_time += pending->counters.local_blk_write_time;
+	shared->counters.temp_blk_read_time += pending->counters.temp_blk_read_time;
+	shared->counters.temp_blk_write_time += pending->counters.temp_blk_write_time;
+	shared->counters.wal_records += pending->counters.wal_records;
+	shared->counters.wal_fpi += pending->counters.wal_fpi;
+	shared->counters.wal_bytes += pending->counters.wal_bytes;
+	shared->counters.wal_buffers_full += pending->counters.wal_buffers_full;
+	shared->counters.jit_functions += pending->counters.jit_functions;
+	shared->counters.jit_generation_time += pending->counters.jit_generation_time;
+	shared->counters.jit_inlining_count += pending->counters.jit_inlining_count;
+	shared->counters.jit_inlining_time += pending->counters.jit_inlining_time;
+	shared->counters.jit_optimization_count += pending->counters.jit_optimization_count;
+	shared->counters.jit_optimization_time += pending->counters.jit_optimization_time;
+	shared->counters.jit_emission_count += pending->counters.jit_emission_count;
+	shared->counters.jit_emission_time += pending->counters.jit_emission_time;
+	shared->counters.jit_deform_count += pending->counters.jit_deform_count;
+	shared->counters.jit_deform_time += pending->counters.jit_deform_time;
+	shared->counters.parallel_workers_to_launch += pending->counters.parallel_workers_to_launch;
+	shared->counters.parallel_workers_launched += pending->counters.parallel_workers_launched;
+	shared->counters.generic_plan_calls += pending->counters.generic_plan_calls;
+	shared->counters.custom_plan_calls += pending->counters.custom_plan_calls;
+
+	pgstat_unlock_entry(entry_ref);
 
-		if (fread(&temp, sizeof(pgssEntry), 1, file) != 1)
-			goto read_error;
+	return true;
+}
 
-		/* Encoding is the only field we can easily sanity-check */
-		if (!PG_VALID_BE_ENCODING(temp.encoding))
-			goto data_error;
+/*
+ * Serialize dshash entry data + query text inline alongside each pgstat entry.
+ * On restart, from_serialized_data reconstructs both.
+ */
+static void
+pgss_to_serialized_data(const PgStat_HashKey *key,
+						const PgStatShared_Common *header,
+						FILE *statfile)
+{
+	static char *qbuffer = NULL;
+	static Size qbuffer_size = 0;
 
-		/* Resize buffer as needed */
-		if (temp.query_len >= buffer_size)
-		{
-			buffer_size = Max(buffer_size * 2, temp.query_len + 1);
-			buffer = repalloc(buffer, buffer_size);
-		}
+	PgStatShared_Pgss *shpgss = (PgStatShared_Pgss *) header;
+	pgssEntry  *entry;
+	bool		found = false;
+	pgssEntry	serialized;
+	char	   *qtext = NULL;
+	int			qtext_len = 0;
 
-		if (fread(buffer, 1, temp.query_len + 1, file) != temp.query_len + 1)
-			goto read_error;
+	if (!pgss_save)
+	{
+		pgstat_write_chunk_s(statfile, &found);
+		return;
+	}
 
-		/* Should have a trailing null, but let's make sure */
-		buffer[temp.query_len] = '\0';
+	pgss_attach_shmem();
 
-		/* Skip loading "sticky" entries */
-		if (IS_STICKY(temp.counters))
-			continue;
+	memset(&serialized, 0, sizeof(pgssEntry));
 
-		/* Store the query text */
-		query_offset = pgss->extent;
-		if (fwrite(buffer, 1, temp.query_len + 1, qfile) != temp.query_len + 1)
-			goto write_error;
-		pgss->extent += temp.query_len + 1;
-
-		/* make the hashtable entry (discards old entries if too many) */
-		entry = entry_alloc(&temp.key, query_offset, temp.query_len,
-							temp.encoding,
-							false);
-
-		/* copy in the actual stats */
-		entry->counters = temp.counters;
-		entry->stats_since = temp.stats_since;
-		entry->minmax_stats_since = temp.minmax_stats_since;
+	entry = dshash_find(pgss_hash, &shpgss->key, false);
+	if (entry)
+	{
+		serialized = *entry;
+		found = true;
+		dshash_release_lock(pgss_hash, entry);
 	}
 
-	/* Read global statistics for pg_stat_statements */
-	if (fread(&pgss->stats, sizeof(pgssGlobalStats), 1, file) != 1)
-		goto read_error;
+	pgstat_write_chunk_s(statfile, &found);
 
-	pfree(buffer);
-	FreeFile(file);
-	FreeFile(qfile);
+	if (!found)
+		return;
 
-	/*
-	 * Remove the persisted stats file so it's not included in
-	 * backups/replication standbys, etc.  A new file will be written on next
-	 * shutdown.
-	 *
-	 * Note: it's okay if the PGSS_TEXT_FILE is included in a basebackup,
-	 * because we remove that file on startup; it acts inversely to
-	 * PGSS_DUMP_FILE, in that it is only supposed to be around when the
-	 * server is running, whereas PGSS_DUMP_FILE is only supposed to be around
-	 * when the server is not running.  Leaving the file creates no danger of
-	 * a newly restored database having a spurious record of execution costs,
-	 * which is what we're really concerned about here.
-	 */
-	unlink(PGSS_DUMP_FILE);
+	pgstat_write_chunk_s(statfile, &serialized);
 
-	return;
+	/* Load query text file once, reuse across all entries */
+	if (!qbuffer)
+		qbuffer = qtext_load_file(&qbuffer_size);
 
-read_error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not read file \"%s\": %m",
-					PGSS_DUMP_FILE)));
-	goto fail;
-data_error:
-	ereport(LOG,
-			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-			 errmsg("ignoring invalid data in file \"%s\"",
-					PGSS_DUMP_FILE)));
-	goto fail;
-write_error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not write file \"%s\": %m",
-					PGSS_TEXT_FILE)));
-fail:
-	if (buffer)
-		pfree(buffer);
-	if (file)
-		FreeFile(file);
-	if (qfile)
-		FreeFile(qfile);
-	/* If possible, throw away the bogus file; ignore any error */
-	unlink(PGSS_DUMP_FILE);
+	if (serialized.query_len >= 0 && qbuffer)
+		qtext = qtext_fetch(serialized.query_offset, serialized.query_len,
+							qbuffer, qbuffer_size);
 
-	/*
-	 * Don't unlink PGSS_TEXT_FILE here; it should always be around while the
-	 * server is running with pg_stat_statements enabled
-	 */
+	if (qtext)
+	{
+		qtext_len = serialized.query_len;
+		pgstat_write_chunk_s(statfile, &qtext_len);
+		pgstat_write_chunk(statfile, qtext, qtext_len + 1);
+	}
+	else
+	{
+		qtext_len = -1;
+		pgstat_write_chunk_s(statfile, &qtext_len);
+	}
 }
 
 /*
- * shmem_shutdown hook: Dump statistics into file.
- *
- * Note: we don't bother with acquiring lock, because there should be no
- * other processes running when this is called.
+ * Deserialize auxiliary data: recreate the dshash entry and store query
+ * text in the file.
  */
-static void
-pgss_shmem_shutdown(int code, Datum arg)
+static bool
+pgss_from_serialized_data(const PgStat_HashKey *key,
+						  PgStatShared_Common *header,
+						  FILE *statfile)
 {
-	FILE	   *file;
-	char	   *qbuffer = NULL;
-	Size		qbuffer_size = 0;
-	HASH_SEQ_STATUS hash_seq;
-	int32		num_entries;
-	pgssEntry  *entry;
-
-	/* Don't try to dump during a crash. */
-	if (code)
-		return;
+	bool		had_entry;
+	pgssEntry	serialized;
+	pgssEntry  *dsh_entry;
+	bool		found;
+	int			qtext_len;
 
-	/* Safety check ... shouldn't get here unless shmem is set up. */
-	if (!pgss || !pgss_hash)
-		return;
+	if (!pgstat_read_chunk_s(statfile, &had_entry))
+		return false;
 
-	/* Don't dump if told not to. */
-	if (!pgss_save)
-		return;
+	if (!had_entry)
+	{
+		pgstat_drop_entry(PGSTAT_KIND_PGSS, key->dboid, key->objid, false);
+		return true;
+	}
 
-	file = AllocateFile(PGSS_DUMP_FILE ".tmp", PG_BINARY_W);
-	if (file == NULL)
-		goto error;
+	if (!pgstat_read_chunk_s(statfile, &serialized))
+		return false;
 
-	if (fwrite(&PGSS_FILE_HEADER, sizeof(uint32), 1, file) != 1)
-		goto error;
-	if (fwrite(&PGSS_PG_MAJOR_VERSION, sizeof(uint32), 1, file) != 1)
-		goto error;
-	num_entries = hash_get_num_entries(pgss_hash);
-	if (fwrite(&num_entries, sizeof(int32), 1, file) != 1)
-		goto error;
+	if (!pgstat_read_chunk_s(statfile, &qtext_len))
+		return false;
 
-	qbuffer = qtext_load_file(&qbuffer_size);
-	if (qbuffer == NULL)
-		goto error;
+	pgss_attach_shmem();
 
-	/*
-	 * When serializing to disk, we store query texts immediately after their
-	 * entry data.  Any orphaned query texts are thereby excluded.
-	 */
-	hash_seq_init(&hash_seq, pgss_hash);
-	while ((entry = hash_seq_search(&hash_seq)) != NULL)
+	dsh_entry = dshash_find_or_insert(pgss_hash, &serialized.key, &found);
+	if (!found)
 	{
-		int			len = entry->query_len;
-		char	   *qstr = qtext_fetch(entry->query_offset, len,
-									   qbuffer, qbuffer_size);
+		pg_atomic_init_u32(&dsh_entry->refcount, pg_atomic_read_u32(&serialized.refcount));
+		dsh_entry->encoding = serialized.encoding;
+		dsh_entry->stats_since = serialized.stats_since;
+		dsh_entry->minmax_stats_since = serialized.minmax_stats_since;
+
+		if (qtext_len >= 0)
+		{
+			char	   *qtext;
+			Size		query_offset;
+
+			qtext = palloc(qtext_len + 1);
+			if (!pgstat_read_chunk(statfile, qtext, qtext_len + 1))
+			{
+				dshash_release_lock(pgss_hash, dsh_entry);
+				pfree(qtext);
+				return false;
+			}
 
-		if (qstr == NULL)
-			continue;			/* Ignore any entries with bogus texts */
+			/* Store in the text file */
+			if (qtext_store(qtext, qtext_len, &query_offset, NULL))
+			{
+				dsh_entry->query_offset = query_offset;
+				dsh_entry->query_len = qtext_len;
+			}
+			else
+			{
+				dsh_entry->query_offset = 0;
+				dsh_entry->query_len = -1;
+			}
 
-		if (fwrite(entry, sizeof(pgssEntry), 1, file) != 1 ||
-			fwrite(qstr, 1, len + 1, file) != len + 1)
+			pfree(qtext);
+		}
+		else
 		{
-			/* note: we assume hash_seq_term won't change errno */
-			hash_seq_term(&hash_seq);
-			goto error;
+			dsh_entry->query_offset = 0;
+			dsh_entry->query_len = -1;
 		}
+
+		pg_atomic_fetch_add_u64(&pgss_shared->nentries, 1);
 	}
+	else
+	{
+		/* Entry already exists (race), skip the text */
+		if (qtext_len >= 0)
+		{
+			char	   *discard = palloc(qtext_len + 1);
 
-	/* Dump global statistics for pg_stat_statements */
-	if (fwrite(&pgss->stats, sizeof(pgssGlobalStats), 1, file) != 1)
-		goto error;
+			pgstat_read_chunk(statfile, discard, qtext_len + 1);
+			pfree(discard);
+		}
+	}
 
-	pfree(qbuffer);
-	qbuffer = NULL;
+	dshash_release_lock(pgss_hash, dsh_entry);
 
-	if (FreeFile(file))
-	{
-		file = NULL;
-		goto error;
-	}
+	return true;
+}
 
-	/*
-	 * Rename file into place, so we atomically replace any old one.
-	 */
-	(void) durable_rename(PGSS_DUMP_FILE ".tmp", PGSS_DUMP_FILE, LOG);
+static void
+pgss_finish(PgStat_StatsFileOp status)
+{
+	switch (status)
+	{
+		case STATS_WRITE:
 
-	/* Unlink query-texts file; it's not needed while shutdown */
-	unlink(PGSS_TEXT_FILE);
+			/*
+			 * Text has been serialized into the pgstat file; remove the
+			 * original.
+			 */
+			unlink(PGSS_TEXT_FILE);
+			break;
 
-	return;
+		case STATS_READ:
+			/* Text file was rebuilt by from_serialized_data; keep it. */
+			break;
 
-error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not write file \"%s\": %m",
-					PGSS_DUMP_FILE ".tmp")));
-	if (qbuffer)
-		pfree(qbuffer);
-	if (file)
-		FreeFile(file);
-	unlink(PGSS_DUMP_FILE ".tmp");
-	unlink(PGSS_TEXT_FILE);
+		case STATS_DISCARD:
+			/* Stats discarded; remove orphaned text file. */
+			unlink(PGSS_TEXT_FILE);
+			break;
+	}
 }
 
-/*
- * Post-parse-analysis hook: mark query with a queryId
+/*--------------------------------------------------------------------------
+ * pgss_store: Record statistics for one statement execution.
+ *
+ * Creates dshash entry if new, then accumulates counters in the pending
+ * pgstat entry.
+ *--------------------------------------------------------------------------
  */
 static void
-pgss_post_parse_analyze(ParseState *pstate, Query *query, const JumbleState *jstate)
+pgss_store(const char *query, int64 queryId,
+		   int query_location, int query_len,
+		   pgssStoreKind kind,
+		   double total_time, uint64 rows,
+		   const BufferUsage *bufusage,
+		   const WalUsage *walusage,
+		   const struct JitInstrumentation *jitusage,
+		   const JumbleState *jstate,
+		   int parallel_workers_to_launch,
+		   int parallel_workers_launched,
+		   PlannedStmtOrigin planOrigin)
 {
-	if (prev_post_parse_analyze_hook)
-		prev_post_parse_analyze_hook(pstate, query, jstate);
+	pgssHashKey key;
+	pgssEntry  *dsh_entry;
+	bool		found;
+	uint64		objid;
+	PgStat_EntryRef *entry_ref;
+	PgStat_PgssPending *pending;
+	char	   *norm_query = NULL;
+	int			encoding = GetDatabaseEncoding();
+
+	Assert(query != NULL);
 
-	/* Safety check... */
-	if (!pgss || !pgss_hash || !pgss_enabled(nesting_level))
+	if (queryId == INT64CONST(0))
 		return;
 
 	/*
-	 * If it's EXECUTE, clear the queryId so that stats will accumulate for
-	 * the underlying PREPARE.  But don't do this if we're not tracking
-	 * utility statements, to avoid messing up another extension that might be
-	 * tracking them.
+	 * Confine our attention to the relevant part of the string, if the query
+	 * is a portion of a multi-statement source string, and update query
+	 * location and length if needed.
 	 */
-	if (query->utilityStmt)
+	query = CleanQuerytext(query, &query_location, &query_len);
+
+	/* Build key */
+	memset(&key, 0, sizeof(pgssHashKey));
+	key.userid = GetUserId();
+	key.dbid = MyDatabaseId;
+	key.queryid = queryId;
+	key.toplevel = (nesting_level == 0);
+
+	/* Create or update dshash registry entry */
+	pgss_attach_shmem();
+
+	/* Fast path: look up with shared lock only */
+	dsh_entry = dshash_find(pgss_hash, &key, false);
+	if (dsh_entry)
 	{
-		if (pgss_track_utility && IsA(query->utilityStmt, ExecuteStmt))
-		{
-			query->queryId = INT64CONST(0);
+		/* Bump refcount atomically under shared lock */
+		uint32		cur = pg_atomic_read_u32(&dsh_entry->refcount);
+
+		if (cur < PGSS_REF_CAP)
+			pg_atomic_compare_exchange_u32(&dsh_entry->refcount, &cur, cur + 1);
+
+		dshash_release_lock(pgss_hash, dsh_entry);
+
+		/* If jstate is provided and kind is PGSS_INVALID, nothing more to do */
+		if (jstate && kind == PGSS_INVALID)
 			return;
-		}
 	}
-
-	/*
+	else
+	{
+		Size		query_offset;
+		int			gc_count;
+		bool		stored;
+		bool		do_gc;
+
+		/* Slow path: insert with exclusive lock */
+		if (jstate)
+		{
+			norm_query = generate_normalized_query(jstate, query,
+												   query_location,
+												   &query_len);
+		}
+
+		/* Store query text in the file */
+		stored = qtext_store(norm_query ? norm_query : query, query_len,
+							 &query_offset, &gc_count);
+
+		/*
+		 * Determine whether we need to garbage collect external query texts.
+		 */
+		do_gc = need_gc_qtexts();
+
+		dsh_entry = dshash_find_or_insert(pgss_hash, &key, &found);
+		if (!found)
+		{
+			pg_atomic_init_u32(&dsh_entry->refcount, 1);
+			dsh_entry->stats_since = GetCurrentTimestamp();
+			dsh_entry->minmax_stats_since = dsh_entry->stats_since;
+			dsh_entry->encoding = encoding;
+
+			if (stored)
+			{
+				dsh_entry->query_offset = query_offset;
+				dsh_entry->query_len = query_len;
+			}
+			else
+			{
+				dsh_entry->query_offset = 0;
+				dsh_entry->query_len = -1;
+			}
+
+			dshash_release_lock(pgss_hash, dsh_entry);
+
+			pg_atomic_fetch_add_u64(&pgss_shared->nentries, 1);
+			entry_dealloc();
+
+			/* If needed, perform garbage collection */
+			if (do_gc)
+				gc_qtexts();
+
+			if (jstate && kind == PGSS_INVALID)
+			{
+				if (norm_query)
+					pfree(norm_query);
+				return;
+			}
+		}
+		else
+		{
+			/* Another backend inserted it concurrently */
+			uint32		cur = pg_atomic_read_u32(&dsh_entry->refcount);
+
+			if (cur < PGSS_REF_CAP)
+				pg_atomic_compare_exchange_u32(&dsh_entry->refcount, &cur, cur + 1);
+			dshash_release_lock(pgss_hash, dsh_entry);
+
+			if (jstate && kind == PGSS_INVALID)
+			{
+				if (norm_query)
+					pfree(norm_query);
+				return;
+			}
+		}
+	}
+
+	if (norm_query)
+		pfree(norm_query);
+
+	/* Accumulate counters in pending pgstat entry */
+	Assert(kind == PGSS_PLAN || kind == PGSS_EXEC);
+
+	objid = pgss_hash_key(&key);
+
+	entry_ref = pgstat_prep_pending_entry(PGSTAT_KIND_PGSS, key.dbid,
+										  objid, NULL);
+	pending = (PgStat_PgssPending *) entry_ref->pending;
+	pending->key = key;
+
+	pending->counters.calls[kind]++;
+	pending->counters.total_time[kind] += total_time;
+
+	if (pending->counters.calls[kind] == 1)
+	{
+		pending->counters.min_time[kind] = total_time;
+		pending->counters.max_time[kind] = total_time;
+		pending->counters.mean_time[kind] = total_time;
+	}
+	else
+	{
+		/*
+		 * Welford's online algorithm for accumulating mean and sum of squared
+		 * deviations. See <http://www.johndcook.com/blog/standard_deviation/>
+		 */
+		double		old_mean = pending->counters.mean_time[kind];
+
+		pending->counters.mean_time[kind] +=
+			(total_time - old_mean) / pending->counters.calls[kind];
+		pending->counters.sum_var_time[kind] +=
+			(total_time - old_mean) * (total_time - pending->counters.mean_time[kind]);
+
+		if (pending->counters.min_time[kind] > total_time)
+			pending->counters.min_time[kind] = total_time;
+		if (pending->counters.max_time[kind] < total_time)
+			pending->counters.max_time[kind] = total_time;
+	}
+
+	pending->counters.rows += rows;
+
+	if (bufusage)
+	{
+		pending->counters.shared_blks_hit += bufusage->shared_blks_hit;
+		pending->counters.shared_blks_read += bufusage->shared_blks_read;
+		pending->counters.shared_blks_dirtied += bufusage->shared_blks_dirtied;
+		pending->counters.shared_blks_written += bufusage->shared_blks_written;
+		pending->counters.local_blks_hit += bufusage->local_blks_hit;
+		pending->counters.local_blks_read += bufusage->local_blks_read;
+		pending->counters.local_blks_dirtied += bufusage->local_blks_dirtied;
+		pending->counters.local_blks_written += bufusage->local_blks_written;
+		pending->counters.temp_blks_read += bufusage->temp_blks_read;
+		pending->counters.temp_blks_written += bufusage->temp_blks_written;
+		pending->counters.shared_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->shared_blk_read_time);
+		pending->counters.shared_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->shared_blk_write_time);
+		pending->counters.local_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->local_blk_read_time);
+		pending->counters.local_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->local_blk_write_time);
+		pending->counters.temp_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->temp_blk_read_time);
+		pending->counters.temp_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->temp_blk_write_time);
+	}
+
+	if (walusage)
+	{
+		pending->counters.wal_records += walusage->wal_records;
+		pending->counters.wal_fpi += walusage->wal_fpi;
+		pending->counters.wal_bytes += walusage->wal_bytes;
+		pending->counters.wal_buffers_full += walusage->wal_buffers_full;
+	}
+
+	if (jitusage)
+	{
+		pending->counters.jit_functions += jitusage->created_functions;
+		pending->counters.jit_generation_time += INSTR_TIME_GET_MILLISEC(jitusage->generation_counter);
+
+		if (INSTR_TIME_GET_MILLISEC(jitusage->deform_counter))
+			pending->counters.jit_deform_count++;
+		pending->counters.jit_deform_time += INSTR_TIME_GET_MILLISEC(jitusage->deform_counter);
+
+		if (INSTR_TIME_GET_MILLISEC(jitusage->inlining_counter))
+			pending->counters.jit_inlining_count++;
+		pending->counters.jit_inlining_time += INSTR_TIME_GET_MILLISEC(jitusage->inlining_counter);
+
+		if (INSTR_TIME_GET_MILLISEC(jitusage->optimization_counter))
+			pending->counters.jit_optimization_count++;
+		pending->counters.jit_optimization_time += INSTR_TIME_GET_MILLISEC(jitusage->optimization_counter);
+
+		if (INSTR_TIME_GET_MILLISEC(jitusage->emission_counter))
+			pending->counters.jit_emission_count++;
+		pending->counters.jit_emission_time += INSTR_TIME_GET_MILLISEC(jitusage->emission_counter);
+	}
+
+	pending->counters.parallel_workers_to_launch += parallel_workers_to_launch;
+	pending->counters.parallel_workers_launched += parallel_workers_launched;
+
+	if (planOrigin == PLAN_STMT_CACHE_GENERIC)
+		pending->counters.generic_plan_calls++;
+	else if (planOrigin == PLAN_STMT_CACHE_CUSTOM)
+		pending->counters.custom_plan_calls++;
+}
+
+/*--------------------------------------------------------------------------
+ * Hook implementations
+ *--------------------------------------------------------------------------
+ */
+
+static void
+pgss_post_parse_analyze(ParseState *pstate, Query *query,
+						const JumbleState *jstate)
+{
+	if (prev_post_parse_analyze_hook)
+		prev_post_parse_analyze_hook(pstate, query, jstate);
+
+	if (!pgss_enabled(nesting_level))
+		return;
+
+	/*
+	 * Clear queryId for EXECUTE so stats accumulate under the PREPARE's
+	 * queryId instead.
+	 */
+	if (query->utilityStmt)
+	{
+		if (pgss_track_utility && IsA(query->utilityStmt, ExecuteStmt))
+		{
+			query->queryId = INT64CONST(0);
+			return;
+		}
+	}
+
+	/*
 	 * If query jumbling were able to identify any ignorable constants, we
 	 * immediately create a hash table entry for the query, so that we can
 	 * record the normalized form of the query string.  If there were no such
@@ -879,10 +1149,6 @@ pgss_post_parse_analyze(ParseState *pstate, Query *query, const JumbleState *jst
 				   PLAN_STMT_UNKNOWN);
 }
 
-/*
- * Planner hook: forward to regular planner, but measure planning time
- * if needed.
- */
 static PlannedStmt *
 pgss_planner(Query *parse,
 			 const char *query_string,
@@ -908,13 +1174,7 @@ pgss_planner(Query *parse,
 		WalUsage	walusage_start,
 					walusage;
 
-		/* We need to track buffer usage as the planner can access them. */
 		bufusage_start = pgBufferUsage;
-
-		/*
-		 * Similarly the planner could write some WAL records in some cases
-		 * (e.g. setting a hint bit with those being WAL-logged)
-		 */
 		walusage_start = pgWalUsage;
 		INSTR_TIME_SET_CURRENT(start);
 
@@ -937,11 +1197,9 @@ pgss_planner(Query *parse,
 		INSTR_TIME_SET_CURRENT(duration);
 		INSTR_TIME_SUBTRACT(duration, start);
 
-		/* calc differences of buffer counters. */
 		memset(&bufusage, 0, sizeof(BufferUsage));
 		BufferUsageAccumDiff(&bufusage, &pgBufferUsage, &bufusage_start);
 
-		/* calc differences of WAL counters. */
 		memset(&walusage, 0, sizeof(WalUsage));
 		WalUsageAccumDiff(&walusage, &pgWalUsage, &walusage_start);
 
@@ -956,17 +1214,11 @@ pgss_planner(Query *parse,
 				   &walusage,
 				   NULL,
 				   NULL,
-				   0,
-				   0,
+				   0, 0,
 				   result->planOrigin);
 	}
 	else
 	{
-		/*
-		 * Even though we're not tracking plan time for this statement, we
-		 * must still increment the nesting level, to ensure that functions
-		 * evaluated during planning are not seen as top-level calls.
-		 */
 		nesting_level++;
 		PG_TRY();
 		{
@@ -987,20 +1239,12 @@ pgss_planner(Query *parse,
 	return result;
 }
 
-/*
- * ExecutorStart hook: start up tracking if needed
- */
 static void
 pgss_ExecutorStart(QueryDesc *queryDesc, int eflags)
 {
-	/*
-	 * If query has queryId zero, don't track it.  This prevents double
-	 * counting of optimizable statements that are directly contained in
-	 * utility statements.
-	 */
-	if (pgss_enabled(nesting_level) && queryDesc->plannedstmt->queryId != INT64CONST(0))
+	if (pgss_enabled(nesting_level) &&
+		queryDesc->plannedstmt->queryId != INT64CONST(0))
 	{
-		/* Request all summary instrumentation, i.e. timing, buffers and WAL */
 		queryDesc->query_instr_options |= INSTRUMENT_ALL;
 	}
 
@@ -1010,9 +1254,6 @@ pgss_ExecutorStart(QueryDesc *queryDesc, int eflags)
 		standard_ExecutorStart(queryDesc, eflags);
 }
 
-/*
- * ExecutorRun hook: all we need do is track nesting depth
- */
 static void
 pgss_ExecutorRun(QueryDesc *queryDesc, ScanDirection direction, uint64 count)
 {
@@ -1031,9 +1272,6 @@ pgss_ExecutorRun(QueryDesc *queryDesc, ScanDirection direction, uint64 count)
 	PG_END_TRY();
 }
 
-/*
- * ExecutorFinish hook: all we need do is track nesting depth
- */
 static void
 pgss_ExecutorFinish(QueryDesc *queryDesc)
 {
@@ -1052,9 +1290,6 @@ pgss_ExecutorFinish(QueryDesc *queryDesc)
 	PG_END_TRY();
 }
 
-/*
- * ExecutorEnd hook: store results if needed
- */
 static void
 pgss_ExecutorEnd(QueryDesc *queryDesc)
 {
@@ -1085,9 +1320,6 @@ pgss_ExecutorEnd(QueryDesc *queryDesc)
 		standard_ExecutorEnd(queryDesc);
 }
 
-/*
- * ProcessUtility hook
- */
 static void
 pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 					bool readOnlyTree,
